
;-------------------------------------------------------------------------------

Global sound_ooh
Global sound_wow
Global sound_eat
Global sound_crash
Global sound_splash
Global sound_wind
Global sound_ocean
Global sound_squeak
Global sound_checkpoint
Global sound_music ; omg teh hills are alive

Global channel_wind
Global channel_ocean
Global channel_squeak
Global channel_music

Global volume_wind#  = 0.0
Global volume_ocean# = 0.0
Global volume_music# = 0.5

;-------------------------------------------------------------------------------

Function sound_init()
	sound_ooh        = LoadSound("data\ooooh.mp3")
	sound_wow        = LoadSound("data\wow.wav")
	sound_eat        = LoadSound("data\eating.wav")
	sound_crash      = LoadSound("data\crash.wav")
	sound_splash     = LoadSound("data\splash.wav")
	sound_wind       = LoadSound("data\wind.mp3")
	sound_ocean      = LoadSound("data\ocean.mp3")
	sound_squeak     = LoadSound("data\squeak.wav")
	sound_checkpoint = LoadSound("data\ding.wav")
	sound_music      = LoadSound("data\18_happy_cycling.mp3")
	
	LoopSound(sound_wind)
	LoopSound(sound_ocean)
	LoopSound(sound_squeak)	
	LoopSound(sound_music)
	
	channel_wind   = PlaySound(sound_wind)
	channel_ocean  = PlaySound(sound_ocean) 
	channel_squeak = PlaySound(sound_squeak) 
	channel_music  = PlaySound(sound_music)
	
	ChannelVolume channel_wind,   volume_wind
	ChannelVolume channel_ocean,  volume_ocean
	ChannelVolume channel_squeak, 0.0
	ChannelVolume channel_music,  0.0
End Function

Function sound_free()
	StopChannel channel_wind
	StopChannel channel_ocean
	StopChannel channel_squeak
	
	FreeSound(sound_ooh)
	FreeSound(sound_wow)
	FreeSound(sound_eat)
	FreeSound(sound_crash)
	FreeSound(sound_splash)
	FreeSound(sound_wind)
	FreeSound(sound_ocean)
	FreeSound(sound_squeak)
	FreeSound(sound_checkpoint)
End Function

;-------------------------------------------------------------------------------

Function music_volume(k#)
	ChannelVolume channel_music, volume_music * k
End Function

Function music_louder()
	volume_music = volume_music + 0.1
	If volume_music > 1.0 volume_music = 1.0
	music_volume(1.0)
End Function

Function music_softer()
	volume_music = volume_music - 0.1
	If volume_music < 0.0 volume_music = 0.0
	music_volume(1.0)
End Function

;-------------------------------------------------------------------------------

Function ocean_volume(k#)
	volume_ocean = k
	ChannelVolume channel_ocean, volume_ocean
End Function

Function wind_volume(k#)
	volume_wind = k
	ChannelVolume channel_wind, volume_wind
End Function

Function fade_volume()
	wind_volume (volume_wind  - 1.0 / 30.0)
	ocean_volume(volume_ocean - 1.0 / 30.0)
End Function

;-------------------------------------------------------------------------------