
;-------------------------------------------------------------------------------

Function create_initial(name$, n)
	B = LoadSprite("data\" + Lower(Mid(name, 2, 1)) + ".png", 2, g_mainCamera)
	A = LoadSprite("data\" + Lower(Mid(name, 1, 1)) + ".png", 2, B)
	C = LoadSprite("data\" + Lower(Mid(name, 3, 1)) + ".png", 2, B)

	ScaleSprite    A,  0.25, 0.25
	ScaleSprite    B,  0.25, 0.25
	ScaleSprite    C,  0.25, 0.25

	PositionEntity A, -0.40, 0, 0
	PositionEntity C,  0.40, 0, 0
	
	If n = 1 EntityColor A, 255, 127, 127
	If n = 2 EntityColor B, 255, 127, 127
	If n = 3 EntityColor C, 255, 127, 127
	
	Return B
End Function

;-------------------------------------------------------------------------------

Function create_timer()
	;   ^
	; AXBCDE
	; 0:00oo

	B = CreateSprite(g_mainCamera)
	X = CreateSprite(B)
	A = CreateSprite(X)
	C = CreateSprite(B)
	D = CreateSprite(C)
	E = CreateSprite(D)

	ScaleSprite A, 0.250, 0.250
	ScaleSprite X, 0.250, 0.250
	ScaleSprite B, 0.250, 0.250
	ScaleSprite C, 0.250, 0.250
	ScaleSprite D, 0.125, 0.125
	ScaleSprite E, 0.125, 0.125
	
	PositionEntity A, -0.25, 0, 0
	PositionEntity X, -0.25, 0, 0
	PositionEntity C,  0.35, 0, 0
	PositionEntity D,  0.27, 0, 0
	PositionEntity E,  0.17, 0, 0
	
	EntityTexture A, number(0)
	EntityTexture X, colon
	EntityTexture B, number(0)
	EntityTexture C, number(0)
	EntityTexture D, number(0)
	EntityTexture E, number(0)
	
	Return B
End Function

Function set_timer(B, time#)
	X = GetChild(B, 1)
	A = GetChild(X, 1)
	C = GetChild(B, 2)
	D = GetChild(C, 1)
	E = GetChild(D, 1)

	T = Int(time * 100)

	m = (T  /  6000)
	s = (T Mod 6000)  /  100
	h = (T Mod 6000) Mod 100

	mo = m Mod 10
	st = s  /  10
	so = s Mod 10
	ht = h  /  10
	ho = h Mod 10

	EntityTexture A, number(mo)
	EntityTexture B, number(st)
	EntityTexture C, number(so)
	EntityTexture D, number(ht)
	EntityTexture E, number(ho)
End Function

;-------------------------------------------------------------------------------