
Global pivot
Global help1
Global help2

Global swap_mode
Global help_mode
Global swap_time
Global help_time

;-------------------------------------------------------------------------------

Function enter_title()
	JoyHit(1)
	KeyHit(57)

	; Initialize the player model.
	
	player_create(0, 0, 0, 180)

	P.Player = First Player
	
	; Rather than simulate the player flying around the city, just attach the
	; model to a pivot and rotate the whole thing.
	
	pivot = CreatePivot()
	EntityParent   P\entity, pivot
	PositionEntity P\entity, 256, 128, 0
	PositionEntity pivot, size / 2, 0, size / 2
	
	P\camera_mode    = CAMERA_BESIDE
	P\propeller_rate = 10

	Animate P\entity, 1, 1

	; Load the title image.
	
	overlay = LoadSprite("data\title.png", 2)
	EntityParent   overlay, P\camera
	ScaleSprite    overlay, 7.5, 7.5
	PositionEntity overlay, 0, 0, 10

	; Load the help images.
	
	help1 = LoadSprite("data\help1.png", 2)
	EntityParent   help1, P\camera
	ScaleSprite    help1, 2, 2
	PositionEntity help1, 0, 0, 3
	HideEntity     help1

	help2 = LoadSprite("data\help2.png", 2)
	EntityParent   help2, P\camera
	ScaleSprite    help2, 2, 2
	PositionEntity help2, 0, 0, 3
	HideEntity     help2
	
	swap_time = MilliSecs()
	help_time = MilliSecs()
	swap_mode = True
	help_mode = True
End Function

Function leave_title()
	EntityParent overlay, 0
	FreeEntity   overlay
	FreeEntity   help1
	FreeEntity   help2
End Function

Function update_title()
	P.Player = First Player

	TurnEntity pivot, 0, 0.1, 0
	TurnEntity P\propeller, 0, 0, P\propeller_rate

	fade_in()
	camera_update()
	shadow_update()
	
	; Switch attract-mode images.
	
	time = MilliSecs()

	If swap_mode Then
		If time - swap_time > 10000 Then
			HideEntity overlay
			ShowEntity help1
			HideEntity help2
			help_time = time
			swap_time = time
			swap_mode = False
		End If
	Else
		If time - swap_time > 15000 Then
			ShowEntity overlay
			HideEntity help1
			HideEntity help2
			swap_time = time
			swap_mode = True
		End If
		If time - help_time > 500 Then
			If help_mode Then
				HideEntity overlay
				HideEntity help1
				ShowEntity help2
				help_time = time
				help_mode = False
			Else
				HideEntity overlay
				ShowEntity help1
				HideEntity help2
				help_time = time
				help_mode = True
			End If
		End If
	End If	
	
	; Wait for a key or button press, then move on
	
	If JoyHit(1) Or KeyHit(57) Then
		Return STATE_SELECT
	Else
		Return STATE_TITLE
	End If
End Function

;-------------------------------------------------------------------------------

Global screen1
Global screen2
Global screen3
Global free1
Global free2
Global centeredX
Global centeredY
Global name1
Global name2
Global name3
Global time1
Global time2
Global time3

Function goto_selection(n)
	EntityColor screen1, 127, 127, 127
	EntityColor screen2, 127, 127, 127
	EntityColor screen3, 127, 127, 127
	
	If n > 3 n = 1
	If n < 1 n = 3
	
	Select n
		Case 1 EntityColor screen1, 255, 255, 255
		Case 2 EntityColor screen2, 255, 255, 255
		Case 3 EntityColor screen3, 255, 255, 255
	End Select
	
	selection = n
End Function

Function goto_freeflight(t)
	EntityColor free1, 127, 127, 127
	EntityColor free2, 127, 127, 127
	
	If Not t Then
		EntityColor free1, 255, 255, 255
	Else
		EntityColor free2, 255, 255, 255
	End If
	
	freeflight = t
End Function

;-------------------------------------------------------------------------------

Function enter_select()
	P.Player = First Player
	
	screen1 = LoadSprite("data\screen1.png", 2)
	screen2 = LoadSprite("data\screen2.png", 2)
	screen3 = LoadSprite("data\screen3.png", 2)
	free1   = LoadSprite("data\free1.png", 2)
	free2   = LoadSprite("data\free2.png", 2)

	EntityParent   screen1, P\camera
	EntityParent   screen2, P\camera
	EntityParent   screen3, P\camera
	EntityParent   free1,   P\camera
	EntityParent   free2,   P\camera
	ScaleSprite    screen1, 0.8, 0.6
	ScaleSprite    screen2, 0.8, 0.6
	ScaleSprite    screen3, 0.8, 0.6
	ScaleSprite    free1,   2.0, 0.25
	ScaleSprite    free2,   2.0, 0.25
	PositionEntity screen1, -1.75,  1.5, 3
	PositionEntity screen2,  0.00,  1.5, 3
	PositionEntity screen3,  1.75,  1.5, 3
	PositionEntity free1,    0.00, -1.0, 3
	PositionEntity free2,    0.00, -1.5, 3

	name1 = create_initial(high_name(1), 0)
	name2 = create_initial(high_name(2), 0)
	name3 = create_initial(high_name(3), 0)

	time1 = create_timer()
	time2 = create_timer()
	time3 = create_timer()

	set_timer(time1, high_time(1))
	set_timer(time2, high_time(2))
	set_timer(time3, high_time(3))

	PositionEntity name1, -1.75,  0.3, 3
	PositionEntity name2,  0.00,  0.3, 3
	PositionEntity name3,  1.75,  0.3, 3
	PositionEntity time1, -1.75, -0.3, 3
	PositionEntity time2,  0.00, -0.3, 3
	PositionEntity time3,  1.75, -0.3, 3

	goto_selection(1)
	goto_freeflight(freeflight)
	
	centered = True	
End Function

Function leave_select()
	P.Player = First Player
	
	EntityParent P\entity, 0

	FreeEntity pivot
	FreeEntity screen1
	FreeEntity screen2
	FreeEntity screen3
	FreeEntity free1
	FreeEntity free2

	FreeEntity name1
	FreeEntity name2
	FreeEntity name3
	FreeEntity time1
	FreeEntity time2
	FreeEntity time3

	player_delete()
End Function

Function update_select()
	P.Player = First Player

	TurnEntity pivot, 0, 0.1, 0
	TurnEntity P\propeller, 0, 0, P\propeller_rate

	fade_in()
	camera_update()
	shadow_update()
	
	; Move the selection using the keyboard.
	
	If KeyHit(200) goto_freeflight(Not freeflight)
	If KeyHit(208) goto_freeflight(Not freeflight)
	If KeyHit(203) goto_selection(selection - 1)
	If KeyHit(205) goto_selection(selection + 1)

	; Move the selection using the joystick.

	If JoyX() > -0.5 And JoyX() < 0.5 centeredX = True
	If JoyY() > -0.5 And JoyY() < 0.5 centeredY = True

	If JoyX() >  0.5 And centeredX Then
		goto_selection(selection + 1)
		centeredX = False
	End If
	If JoyX() < -0.5 And centeredX Then
		goto_selection(selection - 1)
		centeredX = False
	End If
	
	If JoyY() >  0.5 And centeredY Then
		goto_freeflight(Not freeflight)
		centeredY = False
	End If
	If JoyY() < -0.5 And centeredY Then
		goto_freeflight(Not freeflight)
		centeredY = False
	End If

	; When the selection is activated, load the level and start playing.
	
	If JoyHit(1) Or KeyHit(57) Then
		If JoyDown(2)
			course_create("data\course4.map")
		Else
			Select selection
				Case 1 course_create("data\course1.map")
				Case 2 course_create("data\course2.map")
				Case 3 course_create("data\course3.map")
			End Select
		End If

		Return STATE_START
	Else
		Return STATE_SELECT
	End If
End Function

;-------------------------------------------------------------------------------